<?php
/********************************************************************************************
Purpose:	Gets the OAI-PMH feed from the repository using the feed resumption tokens and then stores
			it as an xml file on the server. If the feed is successfully read and stored, calls the processModsDeletions.php script to generate an xml file of deletions (if deletions exist)
			and transfers it to a server where it can be picked up by a Primo VE Discovery Import Profile.
			Sends an email report of the script success or failure and logs any errors.
Created: 	2020-06-15 by M.Gauthier

*** IMPORTANT NOTE: REPLACE variable values enclosed in double angle brackets <<>> with your own values ***
************************************************************************************************/

error_reporting(E_ALL);

//Check for stored data csv file
define('LOCAL_PATH', '<</var/path_to_scripts>>'); // web server path to scripts
define('DATASTORE_PATH', LOCAL_PATH . '<<data/directory>>'); // path to directory where script output is stored

include (LOCAL_PATH . "utils.php"); // contains shared routines 
include (LOCAL_PATH . "sendEmail.php"); // contains shared routines 

define('ERR_LOG_PREFIX', 'OaiModsFeed error');
define('ERROR_LOG_FILE', DATASTORE_PATH . 'modsfeed_error.log');
define('REPORT_EMAIL_SENDER', '<<MAIL SENDER NAME <your_sender.@yourdomain.com>>>');
define('REPORT_EMAIL_RECIPIENTS', '<<your_recipient.@yourdomain.com>>>');

$errorArray = array();

// the Islandora server rejects calls from scripts so create a stream context to emulate a web browser
$context = stream_context_create(
    array(
        "http" => array(
            "header" => "User-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/50.0.2661.102 Safari/537.36"
        )
    )
);

$file = DATASTORE_PATH . "Mods.xml";
$urlBase = 'https://<<YOUR_REPOSITORY.com>>/oai2/request?verb=ListRecords';
$testUrl = '<<https://YOUR_REPOSITORY.com>>/oai2/request?verb=Identify';

$urlStartParam = '&metadataPrefix=mods';
$urlResumeParam = '&resumptionToken=';
$continue = TRUE;
$maxLoop = 1000; // guard against infinite loop during testing
$loopCounter = 0;
$feedUrl = $urlBase . $urlStartParam; // start url

// file headers & footers  to remove with each loop
$fileHeaderPattern1 = preg_quote('<?xml version="1.0" encoding="UTF-8"?>');
$fileHeaderPattern2 = '\n<OAI-PMH.*<ListRecords>';
$fileFooterPattern = '<resumptionToken.+</ListRecords></OAI-PMH>';
$resumptionToken = '';
$linebreak = '\n';
$feedReadErrorFlag = false; // true if there are problem reading the feed 
$maxAttempts = 20;

// there are intermittent issues with reading from ARCA so test if repository is reachable, 
// try again, sleeping between attempts  
for($i = 0; $i < $maxAttempts; $i++){
	$testReadResult = file_get_contents($testUrl, false, $context);
	if($testResult === FALSE){
		$feedReadErrorFlag = true;
		sleep(60*10); // wait 10 minutes before trying again
	} else {
		// able to read from respository so go proceed with script
		$feedReadErrorFlag = false;
		if($i > 0){
			array_push($errorArray, "Took " . $i + 1 . "attempts to read feed.");
		} 
		
		break;
	}
}	
	
if($feedReadErrorFlag){
	$errorMessage = ERR_LOG_PREFIX . " Could not read Mods feed .";
	array_push($errorArray, $errorMessage);
} else {
	// backup the file generated by the last script run
	if(file_exists($file)){
		$backupFile = $file . ".bak";
		
		if(! copy($file, $backupFile)){
			$errorMessage = ERR_LOG_PREFIX . " Could not make backup copy of old feed file.";
			logError($errorMessage, ERROR_LOG_FILE);
			array_push($errorArray, $errorMessage);
		}

		unlink($file);
	}

	// loop through feed with resumption tokens
	while($continue && $loopCounter < $maxLoop){	
		$loopCounter++;
		
		// read the file
		$source = file_get_contents($feedUrl, false, $context);
		if($source === FALSE){ // read contents fails
			$errorMessage = ERR_LOG_PREFIX . " Could not read Mods feed .";
			logError($errorMessage, ERROR_LOG_FILE);
			array_push($errorArray, $errorMessage);
			$feedReadErrorFlag = true;
			break;
		}
		
		// load the file contents into an xml object
		$xmlObj = simplexml_load_string($source);
		
		// check for a resumption token
		if(isset($xmlObj->ListRecords->resumptionToken)){
			$resumptionToken = (string)$xmlObj->ListRecords->resumptionToken;
			if(is_null($resumptionToken) || empty($resumptionToken)){
				$continue = FALSE;
				
			} else {
				// use the resumption token to create the new url
				$feedUrl = $urlBase . $urlResumeParam . $resumptionToken;
			}
		} else {
			$continue = FALSE;
		}

		if($loopCounter > 1){
			// if not the first loop, remove the header from the source code
			$head1Count = 0; // number of header1 replacements
			$source2 = preg_replace("|$fileHeaderPattern1|", '', $source, 1, $head1Count);
			if(! is_null($source2)){ // no header found
				$source = $source2;
			}
			
			$head2Count = 0; // number of header2 replacements
			$source3 = preg_replace("|$fileHeaderPattern2|", '', $source, 1, $head2Count);
			if(! is_null($source3)){
				$source = $source3;
			}
		}

		
		// remove the footer from the source code
		$footCount = 0; // number of footer replacements
		$source4 = preg_replace("|$fileFooterPattern|", '', $source, 1, $footCount);
		if(! is_null($source4)){
			$source = $source4;
		}
		
		// append the file contents to the stored file
		if( ! file_put_contents($file, $source, FILE_APPEND)){
			$errorMessage = ERR_LOG_PREFIX . " Could not write to feed file .";
			logError($errorMessage, ERROR_LOG_FILE);
			array_push($errorArray, $errorMessage);
		}
	}

	if(! $feedReadErrorFlag){
		// add the footer to the file
		$xmlFooter = "</ListRecords>\n</OAI-PMH>";
		if(! file_put_contents($file, $xmlFooter, FILE_APPEND)){
			$errorMessage = ERR_LOG_PREFIX . " Could not write to feed file .";
			logError($errorMessage, ERROR_LOG_FILE);
			array_push($errorArray, $errorMessage);
		}
	}
}
// generate and send a job report
$reportName = "OAI FEED Store Report for " . date('Y-m-d');
$reportOutput = generateReport($reportName, $loopCounter, $errorArray);
sendMail(ERROR_LOG_FILE, REPORT_EMAIL_SENDER, REPORT_EMAIL_RECIPIENTS, $reportName, $reportOutput);


if(! $feedReadErrorFlag){
	// command to run the script that creates the deletions records xml file and transfers it to the sftp server
	$cmd = "<</dir/bin/php>" . LOCAL_PATH . "processModsDeletions.php >> " . DATASTORE_PATH . "script.log";
	exec($cmd);
}
	


/**********************************************************************
   Purpose: Creates a job report as a string
   @param string $reportName
   @param int $loopCounter - number of loops to complete feed
   @param array $errorArray - reference to an array of strings 
   @returns string containing the report 
***********************************************************************/
function generateReport($reportName, $loops, &$errorArray){
	$linebreak = "<br/>";
	$output = "$reportName$linebreak$linebreak";
	$output .= "$loops loops to complete feed.$linebreak";

	if(!empty($errorArray)){
		$output .= "ERRORS FOUND DURING PROCESSING: $linebreak$linebreak";
		foreach($errorArray as $error){
			$output .= "$error.$linebreak";
		}
	} else {
		$output .= "No errors found during processing.";
	}
	
	return $output;
}
?>


